<?php
// Copyright (c) 2002-2003, Index Data.
// $Id: domtools.php,v 1.6 2003/06/10 12:38:11 adam Exp $

function dom_select($node, $xpath) {	// The get_elements_by_tagname doesn't seem to work (the expected way) :-(
    $tag = array_shift($xpath);
    if (is_array($kids = $node->child_nodes())) {
	foreach ($kids as $kid) {
	    if ($kid->tagname == $tag) {
		if (count($xpath) > 0) {
		    return dom_select($kid, $xpath);
		} else {
		    return $kid;
		}
	    }
	}
    }
    return 0;
}

function dom_select_ext ($node, $xpath) {	// The get_elements_by_tagname doesn't seem to work (the expected way) :-(
    $tag = array_shift($xpath);
    if (is_array($kids = $node->child_nodes())) {
	foreach ($kids as $kid) {
	    if ($kid->tagname == $tag) {
		if (count($xpath) > 0) {
		    return dom_select($kid, $xpath);
		} else {
		    $ret = array($kid);
		    while ($kid = $kid->next_sibling()) {
			if ($kid->tagname == $tag) {
			    $ret[] = $kid;
			}
		    }
		    return $ret;
		}
	    }
	}
    }
    return 0;
}


function dump_xml ($node) {
    $ret = "";
    if (is_array($kiddoz = $node->child_nodes())) {
	foreach ($kiddoz as $kid) {
	    $type = $kid->node_type();
	    if ($type == XML_ELEMENT_NODE) {
		$ret .= "<" . $kid->tagname;
		if (is_array($attributes = $kid->attributes())) {
		    foreach ($attributes as $attr) {
			$ret .= " " . $attr->name() . "=\"" . escape_amp($attr->value()) . "\"";
		    }
		}
		$ret .= ">" . dump_xml($kid) . "</" . $kid->tagname . ">";
	    } elseif ($type == XML_TEXT_NODE) {
		$ret .= escape_amp(utf8_decode($kid->content));
	    } else {
		echo "Unknown type of DOM node: $type";
	    }
	}
    }
    return $ret;
}
	    



// $Log: domtools.php,v $
// Revision 1.6  2003/06/10 12:38:11  adam
// Dollar id in headers
//
// Revision 1.5  2002/10/09 13:46:49  sondberg
// Entity references work ok now.
//
// Revision 1.4  2002/10/09 13:27:31  sondberg
// Added the function dump_xml.
//
// Revision 1.3  2002/07/10 13:31:11  sondberg
// Added extended version of dom_select called dom_select_ext.
//
// Revision 1.2  2002/07/05 11:27:19  sondberg
// Removed empty line to avoid confusing the HTTP headers.
//
// Revision 1.1  2002/06/18 09:52:39  sondberg
// Added this file to repository.
//

?>
