<?php

function scheme_tkl_soap($scheme, $path) {
    global $root;
    $fun = '';

    if (!preg_match("'^([^?]*)(\?(.+))?'", $path, $match)) {
	print "Malformed path for tkl-search";
	return '';
    }
    $wsdl = $match[1];
    $args = $match[3];
    $wsdl = preg_replace("/^./", "", $wsdl); // Remove leading /
    if (preg_match("/^\//", $wsdl)) {
	$wsdl = $_SERVER['DOCUMENT_ROOT'] . $root . $wsdl;
    }
    $att = array('target' => $target, 'wrap' => 1);
    $arg_a = array();
    if ($args) {
	foreach (explode('&', $args) as $arg) {
	    if (preg_match("/^tkl:fun=(.*)$/", $arg, $match))
		$fun = $match[1];
	    else
		grok_arg($arg_a, $arg);
	}
    }

    if (!$fun)
	die("SOAP call must specify tkl:fun argument");

    $soap = new soapclient($wsdl, 'wsdl');
    if (!($res = $soap->call($fun, $arg_a)))
	return '<?xml version="1.0" encoding="UTF-8" ?><error>NOTHING</error>';

   $rtext = $soap->response;   // this is probably not technically part of the nusoap API
   $rtext = preg_replace("/^.*?\s*\n\s*\n/s", "", $rtext);
   return $rtext;
}

?>
