<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="html" encoding="ISO-8859-1"/>

<xsl:param name="cwd"/>

<xsl:template match="/badurls">
  <html>
    <head>
      <title>
        Links der skal opdateres
      </title>
      <link rel="stylesheet" type="text/css" href="styles.css" />
    </head>
    <body>
    <table>
        <tr><td align="center"><h1>Links der skal opdateres</h1></td></tr>
        <tr>
            <td>
                <table>
                    <tr>
                        <td colspan="2" style="line-height: 11px;" class="dotted">&#xa0;</td>
                    </tr>
                    <xsl:for-each select="BADURL">
                        <tr>
                             <td>
                                <a href="{URL}"><xsl:value-of select="URL"/></a>
                                <br/>
                                <small>Error code: <xsl:value-of select="ERRORCODE"/>, Checket <xsl:value-of select="CHECKEDNUMBER"/> gange, sidst <xsl:value-of select="CHECKEDLAST"/></small>
                            </td>
                            <td>
                                <a href="xform.php?xml_file={FILENAME}&amp;cwd={$cwd}">Ret</a>
                            </td>
                        </tr>
                         <tr>
                            <td colspan="2" style="line-height: 11px;" class="dotted">&#xa0;</td>
                        </tr>
                    </xsl:for-each>
                    <tr>
                        <td align="center">&amp;lt;&#xa0;<a name="menu"></a><a href="javascript:history.back();">Tilbage</a>&#xa0;&amp;gt;</td>
                    </tr>
                </table>
            </td>
        </tr>
    </table>
    </body>
  </html>
</xsl:template>
</xsl:stylesheet>