<?php
// Copyright (c) 2002-2003, Index Data.
// $Id: dirbrowse.php,v 1.9 2003/06/10 12:38:10 adam Exp $
require "config.php";
require "standards.php";
require "util/catutil.phpi";

?>
<html>
<HEAD>
    <TITLE>Katalog browser</TITLE>
    <link rel="stylesheet" type="text/css" href="styles.css" />
    <?php cat_browse_init()?>
</HEAD>
<body>


<?php

if (!isset($cwd)) {
    echo "<b>Remember to pass info about directory</b>";
    die;
}
if (!($doc_root = check_path($cwd))) {
    exception("Udenfor dokumentomrdet");
    die;
}
$path = get_path($cwd);
foreach ($path as $dir) {
    $pathString .= "$dir/";
}
$abs_cwd = $_SERVER['DOCUMENT_ROOT'] . "/$cwd";

insert_path($browse_script, "&form_name=$form_name&field_name=$field_name");

echo "<p>";
echo "&nbsp;&nbsp;&nbsp;<a href=\"#\" onclick='javascript: InsertTerm(\"/$pathString\",\"$form_name\",\"$field_name\",\"P\")' title=\"Overfr denne sti til editoren\">/</a><br>\n";
if ($dh = @opendir($abs_cwd)) {
    while ($entry = readdir($dh)) {
    	if (neglect_file($entry) or !is_dir("$abs_cwd/$entry")) {
    	    continue;
    	}
    	echo "<a href=\"$browse_script?", makeparms($context, array("cwd"=>"$cwd/$entry", "form_name"=>"$form_name", "field_name"=>"$field_name")), "\">+</a> <a href=\"#\" onclick='javascript: InsertTerm(\"$pathString$entry/\",\"$form_name\",\"$field_name\",\"P\")' title=\"Overfr denne sti til editoren\">$entry</a><br>\n";
    }
    closedir($dh);
}


// $Log: dirbrowse.php,v $
// Revision 1.9  2003/06/10 12:38:10  adam
// Dollar id in headers
//
// Revision 1.8  2003/06/10 12:04:05  marc
// fixed missing '<?php' and '<?php echo ' start tags such that tklite is not dependendt on php.ini configuration 'shortTags = On' MC
//
// Revision 1.7  2003/05/22 10:45:18  sondberg
// If no path is specified in add sym-link or copy record, the path is cwd.
//
// Revision 1.6  2002/07/30 12:50:33  sondberg
// Implemented some filtering upon subdirs.
//
// Revision 1.5  2002/07/26 13:19:30  perhans
// Changed the way paths are returned again.
//
// Revision 1.4  2002/07/26 09:39:49  perhans
// Changed the starting point of the path that is returned.
//
// Revision 1.3  2002/07/25 08:34:26  perhans
// Minor change.
//
// Revision 1.1  2002/07/02 16:28:16  sondberg
// Added this file to repository.
//

?>

</body>
</html>
