<html><head><title>dtv2tkl</title></head>
<body>
<form method="get" action="">
<b>Record conversion -- DTV toolkit => TKL</b>
</p>
<table border="1">
<tr>
<td><b>Input directory</b></td>
<td><input type="text" name="input" size="50" value="<?php echo $input?>"/></td>
</tr>
<tr>
<td><b>Output directory</b></td>
<td><input type="text" name="output" size="50" value="<?php echo $output?>"/></td>
</tr>
<tr><td colspan="2" align="center"><input type="submit"/></td></tr>
</table>
</form>

<?php

$XMLHEAD = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n";

$xsl = xslt_create();

if (!$input || !$output) {
    print "Please enter input and output directory paths";
}
else {
    $input = preg_replace("'/$'", "", $input);
    $output = preg_replace("'/$'", "", $output);
    convert($input, $output);
}

function xml_getelement($xml, $element) {
    preg_match_all("/<$element\s*.*?>\s*(.*?)\s*<\/$element>/s", $xml, $res,
   	 PREG_PATTERN_ORDER);
    return $res[1];
}

function convert($input, $output, $iroot='', $oroot='') {
    if (!$iroot) $iroot = $input;
    if (!$oroot) $oroot = $output;
    global $xsl;
    global $XMLHEAD;
    $d = opendir($input);
    if (!is_dir($output)) {
	mkdir("$output", 0777);
    }
    while (false != ($f = readdir($d))) {
	if (preg_match("/^[0-9]+$/", $f))
	    convert("$input/$f", "$output/$f", $iroot, $oroot);
	elseif ($f == 'cat.dat') {
	    print "$input/$f --> $output/index.tkl<br>";
	    $cat_dat = join('', file("$input/$f"));

	    list($dan) = xml_getelement($cat_dat, 'm_ti_dan');
	    list($eng) = xml_getelement($cat_dat, 'm_ti_eng');

	    $index = "$XMLHEAD" .
	    	"<subject>\n" .
	        "  <title xml:lang=\"en\">$eng</title>\n" .
	        "  <title xml:lang=\"da\">$dan</title>\n" .
		"</subject>\n";
	    $of = fopen("$output/index.tkl", "w");
	    fputs($of, $index);
	    fclose($of);
	}
	elseif (preg_match("/^ent.([0-9]+).dat$/", $f, $match)) {
	    $fileno = $match[1];
	    print "$input/$f --> $output/link$fileno.tkl<br>";

	    if (is_link("$input/$f")) {
		// Get rel part
		$r = readlink("$input/$f");
		$iroot_name = preg_replace("'^.*/'", "", $iroot);
		$r2 = preg_replace("'^.*/$iroot_name'", "", $r);
		$r2 = preg_replace("'/[^/]*$'", "", $r2);
		$delta = preg_replace("'^$iroot/'", "", $input);
		$delta = preg_replace("'[^\/]+'", "..", $delta);
	        print "SYMLINK $input/$f -> $r --> $delta$r2<br>";
		symlink("$delta$r2" . "/link$fileno.tkl", "$output/link$fileno.tkl");
		continue;
	    }


	    $if = $XMLHEAD . join('', file("$input/$f"));
	    $if = preg_replace("/&/", "&amp;", $if);

	    $args = array('_xml' => $if);
	    xslt_process($xsl, 'arg:/_xml', "dtv2tkl.xsl",
	        "$output/link$fileno.tkl", $args);

	}
    }
    closedir($d);
}

?>
</body>
</html>
