<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<?php

require "config.php";
require "standards.php";

?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<title>Editor</title>

<style>
       
    span.btnImage {border: 2px outset white; padding-left: 5px; padding-right: 5px; cursor: default}
    span.btnImage:active {border-style: inset}
    
    .btnImage {cursor: pointer; cursor: hand; padding:2px;}
    
    iframe {border: 1px solid black;}
    
  </style>  

  <script src="js/xbDesignMode.js"></script>  
   
 	<script  language="JavaScript">

	var fieldid = '<?php echo $fieldid?>';

    var myDesignMode=null;

    function load(){
      var myIFrame = document.getElementById("editorWindow");
      myDesignMode = new xbDesignMode(myIFrame);

      if (!document.all) document.getElementById("cssToggle").checked = "true";
      
      // this is the only way I can get IE to load data into the iframe 
	  setTimeout("insert_content()",500);
    }       
    function getSource(){
      document.getElementById("sourceView").innerHTML = replace(myDesignMode.mEditorDocument.body.innerHTML,"<","&lt;");      
    }
    function wysiwyg(){
    	document.getElementById("sourceView").innerHTML = myDesignMode.mEditorDocument.body.innerHTML;      
    }
    function addLink(){
      var myUrl = prompt("Please enter a URL:", "");
      myDesignMode.execCommand("createLink", myUrl);
     }
	function addSymbol(symbol) {
			//alert(symbol);
			myDesignMode.mEditorDocument.body.innerHTML += symbol;  
	}
	function openWin(theURL,winName,features) {
  		window.open(theURL,winName,features);
	}
    function doRichEditCommand(aCommandName, aArg){
      myDesignMode.execCommand(aCommandName, aArg);
      document.getElementById("editorWindow").contentWindow.focus();
    }

	function select(selectname){
    	var cursel = document.getElementById(selectname).selectedIndex;
		// First one is always a label
		if (cursel != 0) {
			var selected = document.getElementById(selectname).options[cursel].value;
			doRichEditCommand(selectname, selected);
			document.getElementById(selectname).selectedIndex = 0;
		}
    } 
  function replace(string,text,by) {
     // Replaces text with by in string
      var strLength = string.length, txtLength = text.length;
      if ((strLength == 0) || (txtLength == 0)) return string;

      var i = string.indexOf(text);
      if ((!i) && (text != string.substring(0,txtLength))) return string;
      if (i == -1) return string;

      var newstr = string.substring(0,i) + by;

      if (i+txtLength < strLength)
        newstr += replace(string.substring(i+txtLength,strLength),text,by);
      return newstr;
    }       
	function get_content () {
		for (var i = 0; i<this.opener.document.main.elements.length; i++) {
			if (this.opener.document.main.elements[i].name == '<?php echo $fieldid?>') {
				return this.opener.document.main.elements[i].value;
			}
		}
    }
    function insert_content () {
		myDesignMode.mEditorDocument.body.innerHTML = get_content();
    }
    
    function update_content () {
        for (var i = 0; i<this.opener.document.main.elements.length; i++) {
            if (this.opener.document.main.elements[i].name == '<?php echo $fieldid?>') {
                this.opener.document.main.elements[i].value = myDesignMode.mEditorDocument.body.innerHTML;
            }
        }
    }

    function close_n_exit () {
        update_content();
        close();
    }

	
  </script>  

  
</head>
<body onLoad="load()">

  <div id="editor" class="tabPanel">

  <p>
  
  
	<select id="formatblock" onchange="select(this.id);">
		<option value="<p>">Normal</option>
		<option value="<p>">Paragraph</option>
		<option value="<h1>">Heading 1 <h1></option>
		<option value="<h2>">Heading 2 <h2></option>
		<option value="<h3>">Heading 3 <h3></option>
		<option value="<h4>">Heading 4 <h4></option>
		<option value="<h5>">Heading 5 <h5></option>
		<option value="<h6>">Heading 6 <h6></option>
		<option value="<address>">Address <ADDR></option>
		<option value="<pre>">Formatted <pre></option>
	</select>
	<select id="fontname" name="selectFont" onchange="select(this.id)">
		<option value="Font" selected>Font</option>
		<option value="Arial, Helvetica, sans-serif">Arial</option>
		<option value="Courier New, Courier, mono">Courier New</option>
		<option value="Times New Roman, Times, serif">Times New Roman</option>
		<option value="Verdana, Arial, Helvetica, sans-serif">Verdana</option>
	</select>

	<img class="btnImage" src="grafik/icon/post_button_bold.gif" width="25" height="24" alt="Bold" title="Bold" onClick="doRichEditCommand('bold');">
	<img class="btnImage" src="grafik/icon/post_button_italic.gif" width="25" height="24" alt="Italic" title="Italic" onClick="doRichEditCommand('italic')">
	<img class="btnImage" src="grafik/icon/post_button_underline.gif" width="25" height="24" alt="Underline" title="Underline" onClick="doRichEditCommand('underline')">
	&nbsp;&nbsp;
	<img class="btnImage" src="grafik/icon/post_button_left_just.gif" width="25" height="24" alt="Align Left" title="Align Left" onClick="doRichEditCommand('justifyleft')">
    <img class="btnImage" src="grafik/icon/post_button_centre.gif" width="25" height="24" alt="Center" title="Center" onClick="doRichEditCommand('justifycenter')">
    <img class="btnImage" src="grafik/icon/post_button_right_just.gif" width="25" height="24" alt="Align Right" title="Align Right" onClick="doRichEditCommand('justifyright')">
    &nbsp;&nbsp;
	<img class="btnImage" src="grafik/icon/post_button_numbered_list.gif" width="25" height="24" alt="Ordered List" title="Ordered List" onClick="doRichEditCommand('insertorderedlist')">
	<img class="btnImage" src="grafik/icon/post_button_list.gif" width="25" height="24" alt="Unordered List" title="Unordered List" onClick="doRichEditCommand('insertunorderedlist')">
	&nbsp;&nbsp;
	<img class="btnImage" src="grafik/icon/post_button_outdent.gif" width="25" height="24" alt="Outdent" title="Outdent" onClick="doRichEditCommand('outdent')">
	<img class="btnImage" src="grafik/icon/post_button_indent.gif" width="25" height="24" alt="Indent" title="Indent" onClick="doRichEditCommand('indent')">
 	&nbsp;&nbsp;           
	<img class="btnImage" src="grafik/icon/post_button_hyperlink.gif" width="25" height="24" alt="Insert Link" title="Insert Link" onClick="addLink();">
	<input type="button" value="Indset symbol" onclick="openWin('utf8.php','utf8','toolbar=0,location=0,status=0,menubar=0,scrollbars=0,resizable=1,width=400,height=420')">
	&nbsp;&nbsp;  
    <select onchange="doRichEditCommand('forecolor',this.options[this.selectedIndex].value)">
      <option>Choose Color</option>
      <option value="black">Black</option>
      <option value="red">Red</option>
      <option value="blue">Blue</option>
    </select>
  
    <iframe src="editor.html" id="editorWindow" width="90%" height="350" style="margin:5px;"></iframe>   
	
  </p>
  <input type="submit" value="Frdig" onclick="close_n_exit()">
  <input type="button" value="Fortryd" onClick="window.close()">
  <input type="button" value="WYSIWYG" onClick="wysiwyg()">
  <input type="button" value="Vis kode" onclick="getSource()">
  <input id="cssToggle" type="checkbox" onclick="myDesignMode.setCSSCreation(!this.checked)">Brug CSS
</div>
	<br />
  <div id="sourceView"></div>
  <br />
   <H6><center>Only Mozilla 1.3+ and IE5.5+ are supported.</center></H6>
</body>
</html>